/**
  Copyright (c) 2008 Freescale Semiconductor
  Freescale Confidential Proprietary
  \file     	Emsci_ReportError.h
  \brief    	This file contains all Emsci Report Error functions as well as \n
              all Error Type definitions.
  \author   	Freescale Semiconductor
  \author     r01160
  \author   	Guadalajara Applications Laboratory RTAC Americas
  \version    1.0
  \date     	9/24/2008 3:00:34 PM
  \warning    DO NOT MODIFY THE NAME OF ERROR TYPES. USER IS ABLE TO CHANGE THEIR VALUES\n
              BUT NOT THEIR NAMES.
  * History:
  
*/
#ifndef _EMSCI_REPORT_ERROR_H_
  #define _EMSCI_REPORT_ERROR_H_

/** Include Definitions from EMSCI Configuration file */
#include "Derivative.h"
/*----------------------------- Definitions ----------------------------*/
/** API Error Types */
#define EMSCI_INIT_ID               ((uint8_t)0x00)
#define EMSCI_CALLBACK_PTR_ID       ((uint8_t)0x01)

/** EMSCI Error Types */
#define EMSCI_E_PARAM_CONFIG        ((uint8_t)0x10)
#define EMSCI_E_UNINIT              ((uint8_t)0x11)
#define EMSCI_E_PARAM_CHANNEL       ((uint8_t)0x12)
#define EMSCI_E_FNC_CALLBACK_UNINIT ((uint8_t)0x13)

/*----------------------------- Functions ------------------------------*/
  #if (EMSCI_ERROR_DETECT == ON)
     void vfnEmsci_Report_Error(uint8_t ApiId, uint8_t ErrorId);
  #endif
#endif